VERSION 5.00
Begin VB.Form frmTest 
   AutoRedraw      =   -1  'True
   Caption         =   "Test"
   ClientHeight    =   5370
   ClientLeft      =   4995
   ClientTop       =   1650
   ClientWidth     =   6480
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   5370
   ScaleWidth      =   6480
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   495
      Left            =   4463
      TabIndex        =   2
      Top             =   4680
      Width           =   1875
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear"
      Height          =   495
      Left            =   2303
      TabIndex        =   1
      Top             =   4680
      Width           =   1875
   End
   Begin VB.CommandButton cmdTryIt 
      Caption         =   "Try It"
      Height          =   495
      Left            =   143
      TabIndex        =   0
      Top             =   4680
      Width           =   1875
   End
End
Attribute VB_Name = "frmTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdClear_Click()
    Cls
End Sub


Private Sub cmdExit_Click()
    End
End Sub

Private Sub cmdTryIt_Click()
    
    Dim strHTMFileName         As String
    Dim strTextFileName        As String
    Dim strBackSlash           As String
    Dim intHTMFileNbr          As Integer
    Dim intTextFileNbr         As Integer
    
    Dim strBuffer              As String
    Dim strCurrentChar         As String * 1
    Dim blnTagPending          As Boolean
    
    Dim lngX                   As Long
    Dim lngBytesRemaining      As Long
    Dim lngCurrentBufferSize   As Long
    Const lngMAX_BUFFER_SIZE   As Long = 10000
    
    ' Prepare the file names ...
    strBackSlash = IIf(Right$(App.Path, 1) = "\", "", "\")
    strHTMFileName = App.Path & strBackSlash & "Files_Lesson1.htm"
    strTextFileName = App.Path & strBackSlash & "TestOut.txt"
    
    Print "Opening files ..."
    
    ' Open the input file ...
    intHTMFileNbr = FreeFile
    Open strHTMFileName For Binary Access Read As #intHTMFileNbr
    
    ' If the file we want to open for output already exists, delete it ...
    If Dir$(strTextFileName) <> "" Then
        Kill strTextFileName
    End If
    ' Open the output file ...
    intTextFileNbr = FreeFile
    Open strTextFileName For Binary Access Write As #intTextFileNbr
    
    ' Initialize the "bytes remaining" variable to the length of the input file ...
    lngBytesRemaining = LOF(intHTMFileNbr)
    
    ' Set up a loop which will process the file in "chunks" of 10,000 bytes at a time.
    ' We will keep track of how many bytes we have remaining to process, and
    ' the loop will continue as long as there are bytes remaining.
    
    Do While lngBytesRemaining > 0
    
        Print "Processing 'chunk' ..."
        
        ' Note: The "buffer" is simply a string variable into which the "current
        ' chunk" of the file will be read.
        
        ' Set the current buffer size to be either the maximum size (10,000) as
        ' long as there are least 10,000 bytes remaining. If there are less (as
        ' there would be the last time through the loop), set the buffer size
        ' equal to the number of bytes remaining.
        
        If lngBytesRemaining >= lngMAX_BUFFER_SIZE Then
            lngCurrentBufferSize = lngMAX_BUFFER_SIZE
        Else
            lngCurrentBufferSize = lngBytesRemaining
        End If
        
        ' Because the Get statement relies on the size of the string variable (the
        ' "buffer") into which the data will be read to know how many bytes to read
        ' from the file, we fill the buffer string variable with a number of blank
        ' spaces - where the number of blank spaces was determined in the statement
        ' above.
        
        strBuffer = String$(lngCurrentBufferSize, " ")
        
        ' The Get statement now reads the next chunk of data from the input file
        ' and stores it in the strBuffer variable.
        
        Get #intHTMFileNbr, , strBuffer
        
        ' The For loop below now processes the current chunk of data character by
        ' character, writing out only the characters that are NOT enclosed in the
        ' HTML tags (i.e., it is skipping every character between a pair of angle
        ' brackets "<" and ">") ...

        For lngX = 1 To lngCurrentBufferSize
            strCurrentChar = Mid$(strBuffer, lngX, 1)
            Select Case strCurrentChar
                Case "<"
                    blnTagPending = True
                Case ">"
                    blnTagPending = False
                Case Else
                    If Not blnTagPending Then
                        ' The current character is outside of the tag brackets, so
                        ' write it out ...
                        Put #intTextFileNbr, , strCurrentChar
                    End If
            End Select
        Next
        
        ' Adjust the "bytes remaining" variable by subtracting the current buffer size
        ' from it ...
        lngBytesRemaining = lngBytesRemaining - lngCurrentBufferSize
        
    Loop
            
    Print "Closing files ..."
    
    ' Close the input and output files ...
    Close #intHTMFileNbr
    Close #intTextFileNbr

    Print "Done."
    
End Sub

